/*
 *	
 * Licensed Materials - Property of IBM
 * 
 * SupportPac CB12 
 * 
 * (c) Copyright IBM Corp. 2013, 2014 All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication, or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *
 */
package genapp.policy;

import java.math.BigInteger;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

import com.ibm.cics.server.Channel;
import com.ibm.cics.server.Container;
import com.ibm.cics.server.Task;

public class DB2InquirePolicy
{
    // <copyright 
    // notice="cics-lm-java-class" 
    // pids="SupportPac CB12" 
    // years="2013,2014" > 
	static final String COPYRIGHT = "Licensed Materials - Property of IBM SupportPac CB12 (c) Copyright IBM Corp. 2013 2014 All Rights Reserved. US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp."; 
    // </copyright> 

    public static void main(String[] args)
	{
    	Task t = Task.getTask();
		
		Channel policyInq = t.getChannel("policyInq");
		byte retVal = 0;
		try {
			Container customer = policyInq.getContainer("customer");
			if(customer!=null) {
				try {
					int customerNo = new BigInteger(customer.get()).intValue();
					
					Class.forName("com.ibm.db2.jcc.DB2Driver");
					Connection con = DriverManager.getConnection("jdbc:default:connection");
					Statement sqlStat = con.createStatement();
					ResultSet result = sqlStat.executeQuery("SELECT policyNumber FROM GENASA1.policy WHERE customerNumber=" + customerNo + ";");
					
					int cnt = 0;
					while(result.next()==true && cnt<1)
					{
						Container policy = policyInq.createContainer("policy"+cnt);
						int policyNo = result.getInt("policyNumber"); 
						policy.put(BigInteger.valueOf(policyNo).toByteArray());
						cnt++;
					}
				} catch (NumberFormatException nfe) {
					retVal = 3;
				} catch (SQLException se) {
					retVal = 7;
					System.err.println("Exception details: " + se.toString() + "\nSQLState: " + se.getSQLState());
					System.err.println("Error code: " + se.getErrorCode());
				}
			} else {
				retVal = 6;
				System.err.println("NO CUSTOMER CONTAINER");
			}
    	} catch (Exception e) {
			retVal=2;
			System.err.println("EXCEPTION IN DB2INQPOL - " + e.getMessage());
		}
    	
    	if(policyInq!=null) {
			try {
				Container returnCont = policyInq.createContainer("retVal");
				returnCont.put(new byte[] { retVal });
			} catch (Exception e) {
				System.err.println("Could not store return code - " + e.getMessage());
			}
		}
    }
}
